rte_node_ip4_api.h(3)

NAME
rte_node_ip4_api.h

SYNOPSIS

#include <rte_common.h>
#include <rte_compat.h>
#include <rte_fib.h>
#include <rte_graph.h>

  Data Structures

struct rte_node_ip4_reassembly_cfg

  Macros

#define RTE_IP4_OUTPUT_FEATURE_ARC_NAME 'rte_ip4_output_arc'

  Enumerations

enum rte_node_ip4_lookup_next { RTE_NODE_IP4_LOOKUP_NEXT_REWRITE, RTE_NODE_IP4_LOOKUP_NEXT_IP4_LOCAL, RTE_NODE_IP4_LOOKUP_NEXT_PKT_DROP }
enum rte_node_ip4_local_next { RTE_NODE_IP4_LOCAL_NEXT_UDP4_INPUT, RTE_NODE_IP4_LOCAL_NEXT_PKT_DROP }
enum rte_node_ip4_reassembly_next { RTE_NODE_IP4_REASSEMBLY_NEXT_PKT_DROP }

  Functions

int rte_node_ip4_route_add (uint32_t ip, uint8_t depth, uint16_t next_hop, enum rte_node_ip4_lookup_next next_node)
int rte_node_ip4_rewrite_add (uint16_t next_hop, uint8_t *rewrite_data, uint8_t rewrite_len, uint16_t dst_port)
__rte_experimental int rte_node_ip4_reassembly_configure (struct rte_node_ip4_reassembly_cfg *cfg, uint16_t cnt)
__rte_experimental int rte_node_ip4_fib_create (int socket, struct rte_fib_conf *conf)
__rte_experimental int rte_node_ip4_fib_route_add (uint32_t ip, uint8_t depth, uint16_t next_hop, enum rte_node_ip4_lookup_next next_node)

Detailed Description

Warning
    EXPERIMENTAL: All functions in this file may be changed or removed without prior notice.

This API allows to do control path functions of ip4_* nodes like ip4_lookup, ip4_rewrite.

Definition in file rte_node_ip4_api.h.

Macro Definition Documentation

  #define RTE_IP4_OUTPUT_FEATURE_ARC_NAME 'rte_ip4_output_arc'
IP4 output arc

Definition at line 29 of file rte_node_ip4_api.h.

Enumeration Type Documentation

  enum rte_node_ip4_lookup_next
IP4 lookup next nodes.

Enumerator

RTE_NODE_IP4_LOOKUP_NEXT_REWRITE
    Rewrite node.

RTE_NODE_IP4_LOOKUP_NEXT_PKT_DROP
    IP Local node. Number of next nodes of lookup node.

Definition at line 35 of file rte_node_ip4_api.h.

  enum rte_node_ip4_local_next
IP4 Local next nodes.

Enumerator

RTE_NODE_IP4_LOCAL_NEXT_UDP4_INPUT
    ip4 Local node.

RTE_NODE_IP4_LOCAL_NEXT_PKT_DROP
    Packet drop node.

Definition at line 47 of file rte_node_ip4_api.h.

  enum rte_node_ip4_reassembly_next
IP4 reassembly next nodes.

Enumerator

RTE_NODE_IP4_REASSEMBLY_NEXT_PKT_DROP
    Packet drop node.

Definition at line 57 of file rte_node_ip4_api.h.

Function Documentation

  int rte_node_ip4_route_add (uint32_t ip, uint8_t depth, uint16_t next_hop, enum rte_node_ip4_lookup_next next_node)
Add ipv4 route to lookup table.

Parameters
    ip IP address of route to be added.
    depth Depth of the rule to be added.
    next_hop Next hop id of the rule result to be added.
    next_node Next node to redirect traffic to.

Returns
    0 on success, negative otherwise.

  int rte_node_ip4_rewrite_add (uint16_t next_hop, uint8_t * rewrite_data, uint8_t rewrite_len, uint16_t dst_port)
Add a next hop's rewrite data.

Parameters
    next_hop Next hop id to add rewrite data to.
    rewrite_data Rewrite data.
    rewrite_len Length of rewrite data.
    dst_port Destination port to redirect traffic to.

Returns
    0 on success, negative otherwise.

  __rte_experimental int rte_node_ip4_reassembly_configure (struct rte_node_ip4_reassembly_cfg * cfg, uint16_t cnt)
Add reassembly node configuration data.

Parameters
    cfg Pointer to the configuration structure.
    cnt Number of configuration structures passed.

Returns
    0 on success, negative otherwise.

  __rte_experimental int rte_node_ip4_fib_create (int socket, struct rte_fib_conf * conf)
Create ipv4 FIB.

Parameters
    socket NUMA socket for FIB memory allocation.
    conf Structure containing FIB configuration.

Returns
    0 on success, negative otherwise.

  __rte_experimental int rte_node_ip4_fib_route_add (uint32_t ip, uint8_t depth, uint16_t next_hop, enum rte_node_ip4_lookup_next next_node)
Add ipv4 route to FIB.

Parameters
    ip IP address of route to be added.
    depth Depth of the rule to be added.
    next_hop Next hop id of the rule result to be added.
    next_node Next node to redirect traffic to.

Returns
    0 on success, negative otherwise.

Author

Generated automatically by Doxygen for DPDK from the source code.